Commit 8dc39f62 authored by Ziye Yang's avatar Ziye Yang Committed by Daniel Verkamp
Browse files

test/rbd: Enable fio test for iSCSI target while using RBD as LUN



Change-Id: Idc138e2207e522113384ebc132447e2fb321e137
Signed-off-by: default avatarZiye Yang <ziye.yang@intel.com>
parent 0aec36be
Loading
Loading
Loading
Loading
+1 −0
Original line number Diff line number Diff line
@@ -99,6 +99,7 @@ if [ $(uname -s) = Linux ]; then
	run_test ./test/iscsi_tgt/rpc_config/rpc_config.sh
	run_test ./test/iscsi_tgt/idle_migration/idle_migration.sh
	run_test ./test/iscsi_tgt/ext4test/ext4test.sh
	run_test ./test/iscsi_tgt/rbd/rbd.sh
	timing_exit iscsi_tgt
fi

+15 −0
Original line number Diff line number Diff line
[Global]
  ReactorMask 0xFFFF
  LogFacility "local7"

[iSCSI]
  NodeBase "iqn.2016-06.io.spdk"
  AuthFile /usr/local/etc/spdk/auth.conf
  Timeout 30
  DiscoveryAuthMethod Auto
  MaxSessions 16
  ImmediateData Yes
  ErrorRecoveryLevel 0

[Rpc]
  Enable Yes
+78 −0
Original line number Diff line number Diff line
#!/usr/bin/env bash

testdir=$(readlink -f $(dirname $0))
rootdir=$testdir/../../..
source $rootdir/scripts/autotest_common.sh

CEPH_DIR=/home/sys_sgsw/ceph/build

# RBD pool name and RBD name
RBD_POOL=rbd
RBD_NAME=foo

if [ ! -d $CEPH_DIR ]; then
	echo "Ceph directory not detected on this system; skipping RBD tests"
	exit 0
fi

(cd $CEPH_DIR && ../src/vstart.sh -d -n -x -l)
/usr/local/bin/rbd create $RBD_NAME --size 1000

if [ -z "$TARGET_IP" ]; then
	echo "TARGET_IP not defined in environment"
	exit 1
fi

if [ -z "$INITIATOR_IP" ]; then
	echo "INITIATOR_IP not defined in environment"
	exit 1
fi

timing_enter rbd

# iSCSI target configuration
PORT=3260
RPC_PORT=5260
INITIATOR_TAG=2
INITIATOR_NAME=ALL
NETMASK=$INITIATOR_IP/32

rpc_py="python $rootdir/scripts/rpc.py"
fio_py="python $rootdir/scripts/fio.py"

$rootdir/app/iscsi_tgt/iscsi_tgt -c $testdir/iscsi.conf &
pid=$!

trap "killprocess $pid; exit 1" SIGINT SIGTERM EXIT

waitforlisten $pid ${RPC_PORT}
echo "iscsi_tgt is listening. Running tests..."

$rpc_py add_portal_group 1 $TARGET_IP:$PORT
$rpc_py add_initiator_group $INITIATOR_TAG $INITIATOR_NAME $NETMASK
$rpc_py construct_rbd_bdev $RBD_POOL $RBD_NAME 4096
# "Ceph0:0" ==> use Ceph0 blockdev for LUN0
# "1:2" ==> map PortalGroup1 to InitiatorGroup2
# "64" ==> iSCSI queue depth 64
# "1 0 0 0" ==> disable CHAP authentication
$rpc_py construct_target_node Target3 Target3_alias 'Ceph0:0' '1:2' 64 1 0 0 0
sleep 1

iscsiadm -m discovery -t sendtargets -p $TARGET_IP:$PORT
iscsiadm -m node --login -p $TARGET_IP:$PORT

trap "iscsicleanup; killprocess $pid; exit 1" SIGINT SIGTERM EXIT

sleep 1
$fio_py 4096 1 randrw 1 verify
$fio_py 131072 32 randrw 1 verify

rm -f ./local-job0-0-verify.state

trap - SIGINT SIGTERM EXIT

iscsicleanup
killprocess $pid
(cd $CEPH_DIR && sh -x ../src/stop.sh || true)

timing_exit rbd